/*
 * (c) 2012, Vyacheslav Grigoryev, <armag_vvg@hotmail.ru>
 *
 * This file is part of "SG WinReg Demo".
 *
 * "SG WinReg Demo" is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * "SG WinReg Demo" is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ERRORS_H_
#define ERRORS_H_

#include <stdexcept>
#include <string>
#include <cassert>

#ifdef DEBUG
# define SG_VERIFY(expr) assert(expr)
#else
# define SG_VERIFY(expr) (void)expr
#endif

namespace sg
{

class win_error : public std::runtime_error
{
	int m_code;
public:
	win_error(const char *pMsg = NULL, DWORD dw = ::GetLastError())
	: std::runtime_error(conv_last_error(pMsg, dw))
	, m_code(dw)
	{}
	const int code() const { return m_code; }
	static const std::string conv_last_error(const char *pMsg, DWORD dw);
};


class type_error : public std::runtime_error
{
public:
	type_error(const std::string &msg)
		: std::runtime_error(msg)
	{}
};


} // end of namespace 'sg'

#endif /* ERRORS_H_ */
